#!/usr/bin/python -tt

import sys

from PyQt4 import QtDeclarative
from PyQt4.QtCore import QObject, QUrl
from PyQt4 import QtCore
from PyQt4.QtGui import QApplication

class Stopwatch(QObject):
    isRunningChanged = QtCore.pyqtSignal()

    def __init__(self):
        self.running = False
        QObject.__init__(self)

    @QtCore.pyqtProperty(bool, notify=isRunningChanged)
    def isRunning(self):
        return self.running

    @QtCore.pyqtSlot()
    def start(self,*args):
        self.running = True

    @QtCore.pyqtSlot()
    def stop(self,*args):
        self.running = False

if __name__ == '__main__':
    app = QApplication(sys.argv)

    view = QtDeclarative.QDeclarativeView()
    engine = view.engine()
    # This alternative does not segfault.  That leads me to believe this is
    # a reference counting issue where setContextObject() does not add a
    # reference to the stopwatch object and therefore the object is deallocated
    # before the qml code can use it.  (setContextProperty() exhibits similar
    # behavior).
    #stopwatch = Stopwatch()
    #engine.rootContext().setContextObject(stopwatch)
    engine.rootContext().setContextObject(Stopwatch())

    view.setSource(QUrl.fromLocalFile('main.qml'))
    view.show()

    sys.exit(app.exec_())
